onEvent('recipes', event => {

  // Meadow Dirt to Coarse Dirt
  event.shaped(Item.of("minecraft:coarse_dirt", 4), [
    ["byg:meadow_dirt", "minecraft:gravel", null],
    ["minecraft:gravel", "byg:meadow_dirt", null],
    [null, null, null],
  ])


  // Clayblock back to 4x Clay
  event.shapeless(Item.of('minecraft:clay_ball', 4), ['minecraft:clay'])



  // 3x Gravel to 1x Flint
  event.shapeless(Item.of('minecraft:flint'), ['minecraft:gravel', 'minecraft:gravel', 'minecraft:gravel'])



  // Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:beach_grass', 'byg:beach_grass'])



  // Short Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:short_beach_grass', 'byg:short_beach_grass'])



  // Cattail to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:cattail', 'byg:cattail'])



  // Leaf Pile to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:leaf_pile', 'byg:leaf_pile'])



  // Meadow Dirt to Dirt
  event.shapeless(Item.of('minecraft:dirt'), ['byg:meadow_dirt'])



  // White Cherry Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:white_cherry_foliage', 'byg:white_cherry_foliage'])



  // Pink Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:pink_cherry_foliage', 'byg:pink_cherry_foliage'])



  // Angel Ring
event.remove({output: "angelring:itemring" })
  event.shaped(Item.of("angelring:itemring"), [
    ["forbidden_arcanus:bat_wing", "minecraft:gold_block", "forbidden_arcanus:bat_wing"],
    ["minecraft:gold_block", "angelring:itemdiamondring", "minecraft:gold_block"],
    ["forbidden_arcanus:golden_dragon_scale", "minecraft:gold_block", "forbidden_arcanus:golden_dragon_scale"],
  ])



  // Diamond Ring
  event.replaceInput(
    { id: "angelring:itemdiamondring" },
    "minecraft:elytra",
    "enigmaticlegacy:fabulous_scroll"
    )



  // Building Gadget
event.remove({output: "buildinggadgets:gadget_building" })
  event.shaped(Item.of("buildinggadgets:gadget_building"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "rftoolscontrol:cpu_core_500", "minecraft:diamond"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Copy-Paste Gadget
event.remove({output: "buildinggadgets:gadget_copy_paste" })
  event.shaped(Item.of("buildinggadgets:gadget_copy_paste"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_500", "minecraft:emerald"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Destruction Gadget
event.remove({output: "buildinggadgets:gadget_destruction" })
  event.shaped(Item.of("buildinggadgets:gadget_destruction"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:ender_pearl", "rftoolscontrol:cpu_core_1000", "minecraft:ender_pearl"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Exchanging Gadget
event.remove({output: "buildinggadgets:gadget_exchanging" })
  event.shaped(Item.of("buildinggadgets:gadget_exchanging"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "minecraft:lapis_lazuli", "minecraft:diamond"],
    ["minecraft:iron_ingot", "rftoolscontrol:cpu_core_1000", "minecraft:iron_ingot"],
  ])

  // Template Manager
event.remove({output: "buildinggadgets:template_manager" })
  event.shaped(Item.of("buildinggadgets:template_manager"), [
    ["minecraft:gold_ingot", "minecraft:redstone", "minecraft:gold_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_2000", "minecraft:emerald"],
    ["minecraft:gold_ingot", "minecraft:lapis_lazuli", "minecraft:gold_ingot"],
  ])



  // Entangled Block
event.remove({output: "entangled:block" })
  event.shaped(Item.of("entangled:block"), [
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
    ["minecraft:obsidian", "#forge:chests/wooden", "minecraft:obsidian"],
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
  ])



  // Magnetism Ring
  event.shaped(Item.of('ringsofascension:ring_magnetism'), [
    ' I ',
    'IEI',
    'RIB'
  ], {
    I: 'minecraft:iron_ingot',
    E: 'minecraft:ender_pearl',
    R: '#forge:dyes/red',
    B: '#forge:dyes/blue'
  })



  // Pied Wool
  event.shaped(Item.of('rats:pied_wool'), [
    'WG ',
    'YW ',
    '   '
  ], {
    W: 'minecraft:white_wool',
    G: '#forge:dyes/green',
    Y: '#forge:dyes/yellow'
  })
  


  // Mining Dim - Block
    event.remove({id: 'mining_dimension:teleporter'})
    event.shaped(Item.of("mining_dimension:teleporter"), [
    ["minecraft:emerald", "#minecraft:logs", "minecraft:diamond"],
    ["#minecraft:logs", "minecraft:diamond_pickaxe", "#minecraft:logs"],
    ["minecraft:gold_block", "#minecraft:logs", "minecraft:iron_block"],
  ])



  // Dusts
  event.replaceOutput(
    { id: "engineerstools:crushing/uranium_grit_crushing_recipe" },
    "immersiveengineering:dust_uranium",
    "silents_mechanisms:uranium_dust"
    )



  // Tesseract
  event.remove({id: 'tesseract:tesseract'})
  event.shaped(Item.of('tesseract:tesseract'), [
    'OUF',
    'ATA',
    'FUO'
  ], {
    O: 'minecraft:obsidian',
    A: 'mekanism:alloy_atomic',
    F: 'fluxnetworks:flux_block',
    T: 'mekanism:teleportation_core',
    U: 'mekanism:ultimate_control_circuit'
  })


  
  // Forbidden And Arcanus - Batwing to Reliquary Batwing
    event.shapeless(Item.of('xreliquary:bat_wing'), ['forbidden_arcanus:bat_wing'])



  // Reliquary - Batwing Batwing to Forbidden And Arcanus Batwing
    event.shapeless(Item.of('forbidden_arcanus:bat_wing'), ['xreliquary:bat_wing'])


  // IE - Steel Sword
  event.replaceInput(
    { id: "immersiveengineering:crafting/sword_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Pickaxe
  event.replaceInput(
    { id: "immersiveengineering:crafting/pickaxe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Shovel
  event.replaceInput(
    { id: "immersiveengineering:crafting/shovel_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Axe
  event.replaceInput(
    { id: "immersiveengineering:crafting/axe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Hoe
  event.replaceInput(
    { id: "immersiveengineering:crafting/hoe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )



  // Sythian Stalk to 2x Bamboo
  event.shaped(Item.of('minecraft:bamboo', 2), [
    ' S ',
    'SGS',
    ' S '
  ], {
    S: 'byg:sythian_stalk_block',
    G: 'minecraft:green_dye'
  })



  // Osmium Ore Chunks to Osmium Ingot
  event.smelting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)
  event.blasting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)



  // Yellorite Ore Chunks to Yellorium Ingot
  event.smelting(Item.of('bigreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)
  event.blasting(Item.of('bigreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)



  // Fruit Log to Charcoal
  event.smelting(Item.of('minecraft:charcoal', 1), 'simplefarming:fruit_log').xp(0.15)



  // MC Sweet Berries to Red Dye
  event.shapeless(Item.of('minecraft:red_dye'), ['minecraft:sweet_berries', 'minecraft:sweet_berries', 'minecraft:sweet_berries'])



  // BYG Blueberries to Blue Dye Fix
  event.remove({id: 'byg:blue_dye'})
  event.shapeless(Item.of('minecraft:blue_dye'), ['byg:blueberries', 'byg:blueberries', 'byg:blueberries'])



  // Ars Nouveau Source Berry to Purple Dye
  event.shapeless(Item.of('minecraft:purple_dye'), ['ars_nouveau:mana_berry', 'ars_nouveau:mana_berry', 'ars_nouveau:mana_berry'])



  // PickleTweaks Watering Can
  event.remove({id: 'pickletweaks:watering_can'})
  event.shaped(Item.of('pickletweaks:watering_can'), [
    ' NI',
    'IBI',
    ' I '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot',
    B: 'minecraft:bowl'
  })



  // Loot Bag Pieces to Loot Bag
  event.shaped(Item.of("lootbagmod:lootbag"), [
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
  ])



  // ExtCaves Cobble Dirt Stone
  event.shaped(Item.of('extcaves:dirtstone_cobble', 4), [
    'CD ',
    'DC ',
    '   '
  ], {
    C: '#forge:cobblestone',
    D: 'minecraft:dirt'
  })



  // ExtCaves Dirt Stone
  event.shaped(Item.of('extcaves:dirtstone', 4), [
    'DS ',
    'SS ',
    '   '
  ], {
    S: '#forge:stone',
    D: 'minecraft:dirt'
  })



  // ExtCaves Ice Bricks
  event.shaped(Item.of('extcaves:bricks_ice', 4), [
    'PB ',
    'BP ',
    '   '
  ], {
    P: 'minecraft:packed_ice',
    B: 'minecraft:bricks'
  })



  // ExtCaves Lava Stone
  event.shaped(Item.of('extcaves:lavastone', 4), [
    'SM ',
    'SS ',
    '   '
  ], {
    M: 'minecraft:magma_block',
    S: '#forge:stone'
  })



  // ExtCaves Marlstone Powder
  event.shaped(Item.of('extcaves:marlstone_powder', 2), [
    'CM ',
    'MC ',
    '   '
  ], {
    M: 'byg:mud_ball',
    C: 'minecraft:clay'
  })



    // ExtCaves Marlstone in Furnace Recipe
  event.smelting(Item.of('extcaves:marlstone', 1), 'extcaves:marlstone_powder').xp(0.10)



  // ExtCaves Sediment Stone
  event.shaped(Item.of('extcaves:sedimentstone', 4), [
    'SC ',
    'CS ',
    '   '
  ], {
    C: 'extcaves:clay_lump',
    S: '#forge:stone'
  })



  // ExtCaves Snow Bricks
  event.shaped(Item.of('extcaves:bricks_snow', 4), [
    'SB ',
    'BS ',
    '   '
  ], {
    S: 'minecraft:snow_block',
    B: 'minecraft:stone_bricks'
  })



  // ExtCaves Snow Bricks Slab
  event.shaped(Item.of('extcaves:bricks_snow_slab', 6), [
    '   ',
    'SSS',
    '   '
  ], {
    S: 'extcaves:bricks_snow',
  })



  // ExtCaves Ice Bricks Slab
  event.shaped(Item.of('extcaves:bricks_ice_slab', 6), [
    '   ',
    'III',
    '   '
  ], {
    I: 'extcaves:bricks_ice',
  })



  // ExtCaves Cobble Dirt Slab
  event.shaped(Item.of('extcaves:dirtstone_cobble_slab', 6), [
    '   ',
    'DDD',
    '   '
  ], {
    D: 'extcaves:dirtstone_cobble',
  })



  // ExtCaves Dirt Stone Slab
  event.shaped(Item.of('extcaves:dirtstone_slab', 6), [
    '   ',
    'DDD',
    '   '
  ], {
    D: 'extcaves:dirtstone',
  })



  // ExtCaves Snow Bricks Stairs
  event.shaped(Item.of('extcaves:bricks_snow_stairs', 4), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'extcaves:bricks_snow',
  })



  // ExtCaves Ice Bricks Stairs
  event.shaped(Item.of('extcaves:bricks_ice_stairs', 4), [
    'I  ',
    'II ',
    'III'
  ], {
    I: 'extcaves:bricks_ice',
  })



  // ExtCaves Cobble Dirt Stairs
  event.shaped(Item.of('extcaves:dirtstone_cobble_stairs', 4), [
    'D  ',
    'DD ',
    'DDD'
  ], {
    D: 'extcaves:dirtstone_cobble',
  })



  // ExtCaves Dirt Stone Stairs
  event.shaped(Item.of('extcaves:dirtstone_stairs', 4), [
    'S  ',
    'SS ',
    'SSS'
  ], {
    S: 'extcaves:dirtstone',
  })



  // Chain Plating BYG
  event.remove({id: 'byg:chain_plating'})
  event.shaped(Item.of('byg:chain_plating', 4), [
    'INI',
    'N N',
    'INI'
  ], {
    I: 'minecraft:iron_ingot',
    N: 'minecraft:iron_nugget'
  })



  // Stone Pebble
  event.remove({id: 'extcaves:pebble_stone'})
  event.shaped(Item.of('extcaves:pebble_stone', 18), [
    'S  ',
    'S  ',
    '   '
  ], {
    S: 'minecraft:stone',
  })



  // Extra Disks Stuff
  event.replaceInput(
    { id: "extradisks:part/65536k_storage_part" },
    "extradisks:16384k_storage_part",
    "extrastorage:storagepart_16384k"
    )

  event.replaceInput(
    { id: "extradisks:part/infinite_fluid_storage_part" },
    "extradisks:1048576k_fluid_storage_part",
    "extrastorage:storagepart_1048576k_fluid"
    )



  // BDB - Tall Water Reeds to Sticks
  event.shaped(Item.of('minecraft:stick'), [
    'R  ',
    'R  ',
    '   '
  ], {
    R: 'betterdefaultbiomes:tall_water_reeds',
  })



  // Flux Plug
  event.remove({output: "fluxnetworks:flux_plug" })
  event.shaped(Item.of('fluxnetworks:flux_plug', 2), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'tesseract:tesseract'
  })



  // Flux Point
  event.remove({output: "fluxnetworks:flux_point" })
  event.shaped(Item.of('fluxnetworks:flux_point'), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'mekanism:teleportation_core'
  })



    // Baked Potato to Baked Potato
  event.remove({output: 'pamhc2crops:bakedsweetpotatoitem'})
  event.smelting(Item.of('pamhc2crops:bakedsweetpotatoitem', 1), 'simplefarming:baked_sweet_potato').xp(0.35)
  event.smoking(Item.of('pamhc2crops:bakedsweetpotatoitem', 1), 'simplefarming:baked_sweet_potato').xp(0.35)
  event.recipes.minecraft.campfire_cooking('pamhc2crops:bakedsweetpotatoitem', 'simplefarming:baked_sweet_potato')



  // Assorted Vegetables
  event.remove({id: "rats:assorted_vegetables"})
  event.shaped(Item.of('rats:assorted_vegetables'), [
    'VVV',
    'VVV',
    'VV '
  ], {
    V: '#forge:vegetables',
  })



  // Maple Fence
  event.remove({id: "byg:maple_fence"})
  event.shaped(Item.of('byg:maple_fence', 3), [
    '   ',
    'PRP',
    'PRP'
  ], {
    R: '#forge:rods/wooden',
    P: 'byg:maple_planks'
  })



  event.replaceInput(
    { id: "byg:maple_fence_gate" },
    "minecraft:stick",
    "#forge:rods/wooden"
    )



  // Mystical Agriculture Constantan Essence Craft
  event.shaped(Item.of('thermal:constantan_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:constantan_essence',
  })



  // Mystical Agriculture Invar Essence Craft
  event.shaped(Item.of('thermal:invar_ingot', 4), [
    'III',
    'I I',
    'III'
  ], {
    I: 'mysticalagriculture:invar_essence',
  })



  // Mystical Agriculture Electrum Essence Craft
  event.shaped(Item.of('thermal:electrum_ingot', 4), [
    'EEE',
    'E E',
    'EEE'
  ], {
    E: 'mysticalagriculture:electrum_essence',
  })



  // Mystical Agriculture Bronze Essence Craft
  event.shaped(Item.of('thermal:bronze_ingot', 4), [
    'BBB',
    'B B',
    'BBB'
  ], {
    B: 'mysticalagriculture:bronze_essence',
  })



  // Mystical Agriculture Nickel Essence Craft
  event.shaped(Item.of('thermal:nickel_ingot', 4), [
    'NNN',
    'N N',
    'NNN'
  ], {
    N: 'mysticalagriculture:nickel_essence',
  })



  // Mystical Agriculture Silver Essence Craft
  event.shaped(Item.of('thermal:silver_ingot', 4), [
    'SSS',
    'S S',
    'SSS'
  ], {
    S: 'mysticalagriculture:silver_essence',
  })



  // Mystical Agriculture Lead Essence Craft
  event.shaped(Item.of('thermal:lead_ingot', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: 'mysticalagriculture:lead_essence',
  })


  // Mystical Agriculture Tin Essence Craft
  event.shaped(Item.of('thermal:tin_ingot', 4), [
    'TTT',
    'T T',
    'TTT'
  ], {
    T: 'mysticalagriculture:tin_essence',
  })



  // Mystical Agriculture Copper Essence Craft
  event.shaped(Item.of('thermal:copper_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:copper_essence',
  })



  event.shaped(Item.of("appliedenergistics2:silicon", 6), [
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null],
  ])



  // Forbidden and Arcanus - Jar
  event.replaceInput(
    { id: "forbidden_arcanus:bottle_block" },
    "#minecraft:planks",
    "#minecraft:wooden_slabs"
    )



  event.remove({id: "rats:plastic_smelting"})
  event.remove({id: "rats:plastic_blast_furnace"})
  event.smelting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)
  event.blasting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)



  // Processed Plastic
  event.shaped(Item.of("kubejs:processed_plastic"), [
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"],
  ])



  event.smelting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)
  event.blasting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)



  // Eternal Stella
  event.remove({id: "forbidden_arcanus:eternal_stella"})
  event.shaped(Item.of("forbidden_arcanus:eternal_stella"), [
    ["kubejs:compressed_xpetrified_orb", "forbidden_arcanus:stellarite_block", "kubejs:compressed_xpetrified_orb"], 
    ["forbidden_arcanus:stellarite_block", "silentgems:enriched_chaos_crystal_block", "forbidden_arcanus:stellarite_block"], 
    ["kubejs:compressed_xpetrified_orb", "forbidden_arcanus:stellarite_block", "kubejs:compressed_xpetrified_orb"],
  ])



  // Compressed Xpetrified Orb
  event.shapeless(Item.of('kubejs:compressed_xpetrified_orb'), ['forbidden_arcanus:xpetrified_orb', 'forbidden_arcanus:xpetrified_orb', 'forbidden_arcanus:xpetrified_orb'])



  // Compressed Xpetrified Orb to 3x Xpetrified Orbs
  event.shapeless(Item.of('forbidden_arcanus:xpetrified_orb', 3), ['kubejs:compressed_xpetrified_orb'])



  // Yellorium Nuggets
  event.shapeless(Item.of('kubejs:yellorium_nugget', 9), ['bigreactors:yellorium_ingot'])



  // Yellorium Ingot from Nugget
  event.shaped(Item.of("bigreactors:yellorium_ingot"), [
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"],
  ])



  // Powered Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Powered Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Powered Anvil 3
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:redstone",
    "silents_mechanisms:redstone_alloy_ingot"
    )



  // Magma Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:magma_block",
    "craftandhunt:blaze_glass_block"
    )

  // Magma Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:obsidian",
    "minecraft:crying_obsidian"
    )

  // Mason Steel
  event.replaceInput(
    { id: "cyclic:mason_steel" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Crystal Sword
  event.replaceInput(
    { id: "cyclic:crystal_sword" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Pickaxe
  event.replaceInput(
    { id: "cyclic:crystal_pickaxe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Shovel
  event.replaceInput(
    { id: "cyclic:crystal_shovel" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Axe
  event.replaceInput(
    { id: "cyclic:crystal_axe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Hoe
  event.replaceInput(
    { id: "cyclic:crystal_hoe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Dusts to Dusts
  event.shapeless(Item.of('thermal:iron_dust'), ['#forge:dusts/iron'])
  event.shapeless(Item.of('thermal:gold_dust'), ['#forge:dusts/gold'])
  event.shapeless(Item.of('thermal:quartz_dust'), ['#forge:dusts/quartz'])
  event.shapeless(Item.of('thermal:copper_dust'), ['#forge:dusts/copper'])
  event.shapeless(Item.of('thermal:tin_dust'), ['#forge:dusts/tin'])
  event.shapeless(Item.of('thermal:lead_dust'), ['#forge:dusts/lead'])
  event.shapeless(Item.of('thermal:silver_dust'), ['#forge:dusts/silver'])
  event.shapeless(Item.of('thermal:nickel_dust'), ['#forge:dusts/nickel'])
  event.shapeless(Item.of('thermal:bronze_dust'), ['#forge:dusts/bronze'])
  event.shapeless(Item.of('thermal:electrum_dust'), ['#forge:dusts/electrum'])
  event.shapeless(Item.of('thermal:invar_dust'), ['#forge:dusts/invar'])
  event.shapeless(Item.of('thermal:constantan_dust'), ['#forge:dusts/constantan'])
  event.shapeless(Item.of('thermal:signalum_dust'), ['#forge:dusts/signalum'])
  event.shapeless(Item.of('thermal:lumium_dust'), ['#forge:dusts/lumium'])
  event.shapeless(Item.of('thermal:enderium_dust'), ['#forge:dusts/enderium'])



  // Uncrafting Grinder
  event.remove({id: 'cyclic:uncrafter'})
  event.shaped(Item.of("cyclic:uncrafter"), [
    ["minecraft:diamond_block", "cyclic:gem_obsidian", "minecraft:diamond_block"], 
    ["cyclic:mason_plate", "minecraft:crying_obsidian", "cyclic:mason_plate"], 
    ["mekanism:block_refined_obsidian", "mekanism:block_refined_obsidian", "mekanism:block_refined_obsidian"],
  ])



  // Pig Fat
  event.remove({id: 'extlights:pig_fat_craft'})
  event.shapeless(Item.of('extlights:pig_fat', 2), ['minecraft:porkchop', 'minecraft:porkchop'])



  // Quark Marble to Astral Marble and vice versa
  event.shapeless(Item.of('astralsorcery:marble_raw'), ['quark:marble'])
  event.shapeless(Item.of('quark:marble'), ['astralsorcery:marble_raw'])



  // AE2 - Calculation Press
  event.shaped(Item.of("appliedenergistics2:calculation_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "appliedenergistics2:purified_certus_quartz_crystal", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Engineering Press
  event.shaped(Item.of("appliedenergistics2:engineering_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "immersiveengineering:toolbox", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Logic Press
  event.shaped(Item.of("appliedenergistics2:logic_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "rftoolsutility:logic", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Silicon Press
  event.shaped(Item.of("appliedenergistics2:silicon_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "#appliedenergistics2:silicon", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])



  // Uranium Stuff
  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_block" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
    )

  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_nugget" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
  )



  // Expanded Storage - Netherite Chest
  event.remove({id: 'expandedstorage:netherite_chest'})
  event.smithing('expandedstorage:netherite_chest', 'expandedstorage:obsidian_chest', 'minecraft:netherite_ingot')

  // Expanded Storage - Wood to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:wood_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:wood_to_netherite_conversion_kit', 'expandedstorage:wood_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Obsidian to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:obsidian_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:obsidian_to_netherite_conversion_kit', 'minecraft:obsidian', 'minecraft:netherite_ingot')

  // Expanded Storage - Diamond to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:diamond_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:diamond_to_netherite_conversion_kit', 'expandedstorage:diamond_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Gold to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:gold_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:gold_to_netherite_conversion_kit', 'expandedstorage:gold_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Iron to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:iron_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:iron_to_netherite_conversion_kit', 'expandedstorage:iron_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')



  // Craft and Hunt - Wither Sword
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_sword'})
  event.smithing('craftandhunt:wither_sword', 'craftandhunt:bone_sword', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Pickaxe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_pickaxe'})
  event.smithing('craftandhunt:wither_pickaxe', 'craftandhunt:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Shovel
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_shovel'})
  event.smithing('craftandhunt:wither_shovel', 'craftandhunt:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Axe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_axe'})
  event.smithing('craftandhunt:wither_axe', 'craftandhunt:bone_axe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Hoe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_hoe'})
  event.smithing('craftandhunt:wither_hoe', 'craftandhunt:bone_hoe', 'minecraft:wither_skeleton_skull')



  // Forbidden and Arcanus (CAH) - Wither Sword
  event.smithing('craftandhunt:wither_sword', 'forbidden_arcanus:bone_sword', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Pickaxe
  event.smithing('craftandhunt:wither_pickaxe', 'forbidden_arcanus:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Shovel
  event.smithing('craftandhunt:wither_shovel', 'forbidden_arcanus:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Axe
  event.smithing('craftandhunt:wither_axe', 'forbidden_arcanus:bone_axe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Hoe
  event.smithing('craftandhunt:wither_hoe', 'forbidden_arcanus:bone_hoe', 'minecraft:wither_skeleton_skull')


  // Connecting Glass
  event.remove({id: 'connectedglass:borderless_glass1'})
  event.shaped(Item.of('connectedglass:borderless_glass', 9), [
    'GGG',
    'GGG',
    'GGG'
  ], {
    G: 'minecraft:glass',
  })


  // Glass Wall
  event.shaped(Item.of('variant16x:glass_wall', 6), [
    ' C ',
    'GGG',
    'GGG'
  ], {
    G: '#forge:glass/colorless',
    C: 'minecraft:cobblestone_wall'
  });


});